"""Add session_secret column.

Revision ID: 4566843039d6
Revises: 8f4e4eae5eb2
Create Date: 2023-09-14 19:33:51.646943

"""
import secrets

import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = '4566843039d6'
down_revision = '8f4e4eae5eb2'
branch_labels = None
depends_on = None

def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('users', sa.Column('session_secret', sa.LargeBinary(length=32), nullable=True))
    bind = op.get_bind()
    user_ids = bind.execute(sa.text("SELECT id FROM users;")).scalars()
    for user_id in user_ids:
        bind.execute(
            sa.text("UPDATE users SET session_secret=:secret WHERE id=:user_id;"),
            {
                "secret": secrets.token_bytes(32),
                "user_id": user_id,
            },
        )
    # ### end Alembic commands ###

def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('users', 'session_secret')
    # ### end Alembic commands ###
